AddDamageType("CombatRifle",   '<bitmap:add-ons/Weapon_CombatRifle/CI_fnscar> %1',    '%2 <bitmap:add-ons/Weapon_CombatRifle/CI_fnscar> %1',0.5,1);
datablock ProjectileData(fnscarProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::CombatRifle;
   radiusDamageType    = $DamageType::CombatRifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 50;
   verticalImpulse	  = 50;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 3500;
   fadeDelay           = 3000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Combat Rifle Bullet";
};


//////////
// item //
//////////
datablock ItemData(fnscarGunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./fnscarl.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Combat Rifle";
	iconName = "./Icon_fnscar";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = fnscarGunImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(fnscarGunImage)
{
   // Basic Item properties
   shapeFile = "./fnscarl.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = fnscarProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 3.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = fnscarGunItem.colorShiftColor;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "FireA";

	stateName[2] = "FireA";
	stateEjectShell[2]       = true;
	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "FireB";
        stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.04;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = gunShot1Sound;
        stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "FireB";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "FireC";
        stateWaitForTimeout[3] = true;
	stateTimeoutValue[3] = 0.04;
	stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = gunShot1Sound;
        stateEmitter[3]					= gunFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";

	stateName[4] = "FireC";
	stateEjectShell[4]       = true;
	stateSequence[4] = "Fire";
	stateTransitionOnTimeout[4] = "FireD";
        stateWaitForTimeout[4] = true;
	stateTimeoutValue[4] = 0.04;
	stateFire[4] = true;
	stateAllowImageChange[4] = false;
	stateScript[4] = "onFire";
	stateSound[4] = gunShot1Sound;
        stateEmitter[4]					= gunFlashEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";

	stateName[5] = "FireD";
	stateEjectShell[5]       = true;
	stateSequence[5] = "Fire";
	stateTransitionOnTimeout[5] = "FireE";
        stateWaitForTimeout[5] = true;
	stateTimeoutValue[5] = 0.04;
	stateFire[5] = true;
	stateAllowImageChange[5] = false;
	stateScript[5] = "onFire";
	stateSound[5] = gunShot1Sound;
        stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";

	stateName[6] = "FireE";
	stateEjectShell[6]       = true;
	stateSequence[6] = "Fire";
	stateTransitionOnTimeout[6] = "Smoke";
        stateWaitForTimeout[6] = true;
	stateTimeoutValue[6] = 0.04;
	stateFire[6] = true;
	stateAllowImageChange[6] = false;
	stateScript[6] = "onFire";
	stateSound[6] = gunShot1Sound;
        stateEmitter[6]					= gunFlashEmitter;
	stateEmitterTime[6]				= 0.05;
	stateEmitterNode[6]				= "muzzleNode";

        stateName[7] = "Smoke";
	stateEmitter[7]					= gunSmokeEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzleNode";
	stateTimeoutValue[7]            = 0.35;
	stateTransitionOnTimeout[7]     = "Ready";
};

function fnscarGunImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
	%projectile = %this.projectile;
	%spread = 0.0012;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}